<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<form class="ls-form" xmlns="http://www.w3.org/1999/html">

  <div class="modal-header">
    <h4
      class="modal-title"
      id="modal-basic-title"
      [innerText]="isForIncomingTypes ? ipngMessage.ADD_INCOMING_LINK_POPUP_TITLE : ipngMessage.ADD_OUTGOING_LINK_POPUP_TITLE">
    </h4>
    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="onCancelButtonClicked()">
    </button>
  </div>

  <div class="modal-body d-flex flex-column">
    <app-search-bar
      id="title-search"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="ipngMessage.TYPOLOGY_SEARCH_BAR_TITLE">
    </app-search-bar>
    <div class="mt-4 mx-3 w-100 d-flex flex-row pb-2">

      <ng-container *ngIf="isForIncomingTypes">
        <div class="mt-4 mx-3 w-50">
          <ng-container *ngTemplateOutlet="ipngTypeList"></ng-container>
        </div>

        <div class="mt-4 mx-3 w-50">
          <ng-container *ngTemplateOutlet="localSubtypeList"></ng-container>
        </div>
      </ng-container>

      <ng-container *ngIf=" ! isForIncomingTypes">
        <div class="mt-4 mx-3 w-50">
          <ng-container *ngTemplateOutlet="localSubtypeList"></ng-container>
        </div>

        <div class="mt-4 mx-3 w-50">
          <ng-container *ngTemplateOutlet="ipngTypeList"></ng-container>
        </div>
      </ng-container>

    </div>

    <button
      ls-button [icon]="commonIcons.ADD_ICON"
      [text]="ipngMessage.ADD_LINK_BUTTON_TITLE"
      [disabled]="!canAddLink()"
      (click)="addLink()">
    </button>

    <div class="mt-4 mx-3 w-100">

      <h3
        id="linkListTitle"
        class="fw-bold"
        [innerText]="ipngMessage.ADD_LINK_POPUP_TABLE_TITLE_LINKS">
      </h3>

      <div class="h-100 m-0 table-overflow border-top">
        <table
          aria-labelledby="linkListTitle"
          class="bg-white table table-striped table-borderless table-scroll">
          <thead>
            <tr>
              <ng-container *ngIf="isForIncomingTypes">
                <th scope="col" class="bg-white fw-bold w-50" [innerText]="ipngMessage.TABLE_SUBTITLE_IPNG_TYPE"></th>
                <th scope="col" class="bg-white fw-bold w-50" [innerText]="ipngMessage.TABLE_SUBTITLE_IPARAPHEUR_SUBTYPE"></th>
              </ng-container>
              <ng-container *ngIf=" ! isForIncomingTypes">
                <th scope="col" class="bg-white fw-bold w-50" [innerText]="ipngMessage.TABLE_SUBTITLE_IPARAPHEUR_SUBTYPE"></th>
                <th scope="col" class="bg-white fw-bold w-50" [innerText]="ipngMessage.TABLE_SUBTITLE_IPNG_TYPE"></th>
              </ng-container>
              <th
                scope="col"
                class="bg-white fw-bold col-icon-fixed-size"
                [innerText]="ipngMessage.ADD_LINK_POPUP_TABLE_SUBTITLE_ACTION"></th>
            </tr>
          </thead>
          <tbody>
            <tr class="w-100" *ngFor="let link of links; let i = index">

              <ng-container *ngIf="isForIncomingTypes">
                <td>
                  {{ link.ipngType | ipngTypologyName }}
                </td>
                <td class="col-icon-fixed-size">
                  {{ formatTenantTypeText(link.tenantType) }}
                </td>
              </ng-container>

              <ng-container *ngIf=" ! isForIncomingTypes">
                <td class="col-icon-fixed-size">
                  {{ formatTenantTypeText(link.tenantType) }}
                </td>
                <td>
                  {{ link.ipngType | ipngTypologyName }}
                </td>
              </ng-container>

              <td class="col-icon-fixed-size">
                <button
                  type="button"
                  class="btn text-primary ms-2"
                  (click)="removeLink(i)">
                  <fa-icon [icon]="unlinkIcon"></fa-icon>
                </button>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
      <div class="w-100 fst-italic text-center" *ngIf="links.length === 0" [innerText]="ipngMessage.TABLE_NO_LINKS"></div>
    </div>
  </div>

  <div class="modal-footer">
    <button ls-button-cancel (click)="cancel()"></button>
    <button
      ls-button-save [processing]="isProcessing"
      (click)="validate()"
      [icon]="commonIcons.SAVE_ICON"></button>
  </div>


</form>


<ng-template #localSubtypeList>

  <h3
    id="subtypesListLabel"
    class="fw-bold pb-2"
    [innerText]="ipngMessage.TABLE_SUBTITLE_IPARAPHEUR_SUBTYPE">
  </h3>

  <div class="h-100 m-0 table-overflow border-top">
    <table
      aria-labelledby="subtypesListLabel"
      class="bg-white table table-striped table-borderless">
      <tbody>
        <tr *ngFor="let subtype of sortedTenantSubtypes" [ngClass]="{
              'selected-table-row-background': isSubtypeSelected(subtype),
              'text-primary': isSubtypeSelected(subtype)
              }">
          <td class="col-icon-fixed-size">
            <button
              type="button"
              class="btn text-primary ms-2"
              (click)="selectSubtype(subtype)">
              <fa-icon [icon]="faThumbtack"></fa-icon>
            </button>
          </td>
          <td>
            {{ formatTenantTypeText(subtype) }}
          </td>
          <td class="col-icon-fixed-size">
            <button
              type="button"
              class="btn text-primary ms-2">
              <fa-icon [icon]="faEye"></fa-icon>
            </button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>
</ng-template>

<ng-template #ipngTypeList>

  <h3
    id="typeListLabel"
    class="fw-bold pb-2"
    [innerText]="ipngMessage.TABLE_SUBTITLE_IPNG_TYPE">
  </h3>

  <div class="h-100 m-0 table-overflow border-top">
    <table
      aria-labelledby="typeListLabel"
      class="bg-white table table-striped table-borderless">
      <tbody>
        <tr *ngFor="let ipngType of sortedIpngTypes" [ngClass]="{
              'selected-table-row-background': isIpngTypeSelected(ipngType),
              'text-primary': isIpngTypeSelected(ipngType)
              }">
          <td class="col-icon-fixed-size">
            <button
              type="button"
              class="btn text-primary ms-2"
              (click)="selectIpngType(ipngType)">
              <fa-icon [icon]="faThumbtack"></fa-icon>
            </button>
          </td>
          <td>
            {{ ipngType | ipngTypologyName }}
          </td>
          <td class="col-icon-fixed-size">
            <button
              type="button"
              class="btn text-primary ms-2">
              <fa-icon [icon]="faEye"></fa-icon>
            </button>
          </td>
        </tr>
      </tbody>
    </table>
  </div>

</ng-template>
